   (DEFUN MAIN (LAMBDA NIL
   ;  p     ;
      (PRIN1 "Input first letter... ")
      (PRINT (SETQ WORD1 (LIST (READ))))
      (LOOP
         (PRIN1 "Input keyword: ") (SETQ WORD2 (READ))
         ( (EQ WORD2 END) 'BYE-BYE )
         ;  &    WORD2 ;
         (SETQ WORD2 (APPEND (UNPACK WORD2) (LIST '&)))
         (SETQ WORD1 (INSERT WORD2 WORD1))
         (PRINT WORD1)
      )
      (LOOP
         (PRIN1 "Input keyword for search: ")
         (SETQ WORD2 (READ))
         ( (EQ WORD2 END) 'BYE-BYE )
         (SETQ WORD2 (APPEND (UNPACK WORD2) (LIST '&)))
         (PRIN1 "Result: ") (PRINT (SEARCH WORD2 WORD1))
      )
   ))
   ; ----------------------------- ;
   (DEFUN SEARCH (LAMBDA (WORD TRIE)
   ;   WORD   TRIE ;
      (COND ( (NULL TRIE) NIL )
            ( (EQUAL WORD TRIE) T )
            ( (EQ (CAR WORD) '&) "Subword" )
            ( (MEMBER (CAR WORD) TRIE)
                (SEARCH (CDR WORD)
                        (CADR (MEMBER (CAR WORD) TRIE)))
            )
            (  T  NIL )
      )
   ))
   ; ---------------------------- ;
   (DEFUN INSERT (LAMBDA (WORD LST)
   ;   WORD  p LST ;
      (COND ( (NULL LST) (TREE WORD) )
            ( (NULL WORD) LST )
            ( (NOT (MEMBER (CAR WORD) LST))
                      (APPEND LST (TREE WORD)) )
            ; -------------------------------- ;
            ( (AND (EQ (CAR LST) (CAR WORD))
                   (ATOM (CADR LST))
                   (NULL (CDR WORD))
              )
                      (CONS (CAR LST) (CDR LST))
            )
            ; ---------------------------- ;
            ( (AND (EQ (CAR LST) (CAR WORD))
                   (ATOM (CADR LST))
              )
                      (CONS (CAR LST)
                            (APPEND (LIST (TREE (CDR WORD)))
                                    (CDR LST)))
            )
            ; ---------------------------- ;
            ( (AND (EQ (CAR LST) (CAR WORD))
                   (NOT (ATOM (CADR LST))))
                      (CONS (CAR LST)
                            (APPEND
                               (LIST (INSERT (CDR WORD)
                                             (CADR LST)))
                               (CDDR LST)))
            )
            ; ----------------------------- ;
            ( (NOT (EQ (CAR LST) (CAR WORD)))
                    (CONS (CAR LST) (INSERT WORD (CDR LST)))
            )
      )
   ))
   ; --------------------- ;
   (DEFUN TREE (LAMBDA (LST)
   ; p     (A B C ...)   ;
   ;   : (A (B (C (...)))) ;
      (COND ( (NULL (CDR LST)) (LIST (CAR LST)) )
            (    T   (LIST (CAR LST) (TREE (CDR LST))) )
      )
   ))
   ; ----------------------- ;
   (DEFUN APPEND (LAMBDA (X Y)
   ;   APPEND  p ,   ;
   ;   LST1,    LST2 ;
       (COND ( (NULL X) Y )
             (  T  (CONS (CAR X) (APPEND (CDR X) Y)) )
       )
   ))
(RDS)